Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -2466,13 +2407,7 @@
     INTEGER(iwp), INTENT(IN)       ::  nzt_do    !< vertical upper limit of the data output (usually nz_do3d)
 
-    INTEGER(iwp), PARAMETER                            ::  nd = 5  !< number of directions
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  dirint =  (/      iup,   isouth,   inorth,    iwest,    ieast /)  !<
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  diridx =  (/       -1,        1,        0,        3,        2 /)
-                                                           !< index for surf_*_v: 0:3 = (North, South, East, West)
-    CHARACTER(LEN=6), DIMENSION(0:nd-1), PARAMETER     ::  dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)  !<
-
-
     INTEGER(iwp)  ::  ids, idsint, idsidx        !<
     INTEGER(iwp)  ::  i, j, k, iwl, istat, l, m  !< running indices
+    LOGICAL       ::  horizontal                 !< horizontal upward or downeard facing surface
 
     LOGICAL, INTENT(OUT)           ::  found     !<
@@ -2497,4 +2432,7 @@
         ENDIF
     ENDDO
+    horizontal = ( ( idsint == iup ) .OR. (idsint == idown ) )
+    l = idsidx !< shorter direction index name
+
     IF ( ids == -1 )  THEN
         var = TRIM( variable )
@@ -2538,13 +2476,12 @@
 !
 !--       Array of surface height (z)
-          IF ( idsint == iup )  THEN
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                k = surf_usm_h%k(m)
+          IF ( horizontal )  THEN
+             DO  m = 1, surf_usm_h(l)%ns
+                i = surf_usm_h(l)%i(m)
+                j = surf_usm_h(l)%j(m)
+                k = surf_usm_h(l)%k(m)
                 temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, KIND = sp) )
              ENDDO
           ELSE
-             l = idsidx
              DO  m = 1, surf_usm_v(l)%ns
                 i = surf_usm_v(l)%i(m)
@@ -2558,13 +2495,12 @@
 !
 !--       Surface category
-          IF ( idsint == iup )  THEN
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                k = surf_usm_h%k(m)
-                temp_pf(k,j,i) = surf_usm_h%surface_types(m)
+          IF ( horizontal )  THEN
+             DO  m = 1, surf_usm_h(l)%ns
+                i = surf_usm_h(l)%i(m)
+                j = surf_usm_h(l)%j(m)
+                k = surf_usm_h(l)%k(m)
+                temp_pf(k,j,i) = surf_usm_h(l)%surface_types(m)
              ENDDO
           ELSE
-             l = idsidx
              DO  m = 1, surf_usm_v(l)%ns
                 i = surf_usm_v(l)%i(m)
@@ -2578,13 +2514,12 @@
 !
 !--       Transmissivity window tiles
-          IF ( idsint == iup )  THEN
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                k = surf_usm_h%k(m)
-                temp_pf(k,j,i) = surf_usm_h%transmissivity(m)
+          IF ( horizontal )  THEN
+             DO  m = 1, surf_usm_h(l)%ns
+                i = surf_usm_h(l)%i(m)
+                j = surf_usm_h(l)%j(m)
+                k = surf_usm_h(l)%k(m)
+                temp_pf(k,j,i) = surf_usm_h(l)%transmissivity(m)
              ENDDO
           ELSE
-             l = idsidx
              DO  m = 1, surf_usm_v(l)%ns
                 i = surf_usm_v(l)%i(m)
@@ -2599,13 +2534,12 @@
 !--       Array of sensible heat flux from surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wshf_eb(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wshf_eb(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2616,13 +2550,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wshf_eb_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wshf_eb_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2639,13 +2572,12 @@
 !--       Array of latent heat flux from surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%qsws(m) * l_v
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%qsws(m) * l_v
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2656,13 +2588,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%qsws_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%qsws_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2678,13 +2609,12 @@
 !--       Array of latent heat flux from vegetation surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%qsws_veg(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%qsws_veg(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2695,13 +2625,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%qsws_veg_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%qsws_veg_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2717,13 +2646,12 @@
 !--       Array of latent heat flux from surfaces with liquid
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%qsws_liq(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%qsws_liq(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2734,13 +2662,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%qsws_liq_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%qsws_liq_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2756,13 +2683,12 @@
 !--       Array of heat flux from ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wghf_eb(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wghf_eb(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2773,13 +2699,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wghf_eb_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wghf_eb_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2795,13 +2720,12 @@
 !--       Array of heat flux from window ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wghf_eb_window(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wghf_eb_window(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2812,13 +2736,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wghf_eb_window_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wghf_eb_window_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2834,10 +2757,10 @@
 !--       Array of heat flux from green ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wghf_eb_green(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wghf_eb_green(m)
                 ENDDO
              ELSE
@@ -2851,13 +2774,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%wghf_eb_green_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%wghf_eb_green_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2873,13 +2795,12 @@
 !--       Array of heat flux from indoor ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%iwghf_eb(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%iwghf_eb(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2890,13 +2811,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%iwghf_eb_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%iwghf_eb_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2912,13 +2832,12 @@
 !--       Array of heat flux from indoor window ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%iwghf_eb_window(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%iwghf_eb_window(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2929,13 +2848,12 @@
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%iwghf_eb_window_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%iwghf_eb_window_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2951,30 +2869,28 @@
 !--       Surface temperature for surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = t_surf_wall_h(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = t_surf_wall_h(l)%val(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
                    j = surf_usm_v(l)%j(m)
                    k = surf_usm_v(l)%k(m)
-                   temp_pf(k,j,i) = t_surf_wall_v(l)%t(m)
+                   temp_pf(k,j,i) = t_surf_wall_v(l)%val(m)
                 ENDDO
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%t_surf_wall_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%t_surf_wall_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -2990,31 +2906,29 @@
 !--       Surface temperature for window surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = t_surf_window_h(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = t_surf_window_h(l)%val(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
                    j = surf_usm_v(l)%j(m)
                    k = surf_usm_v(l)%k(m)
-                   temp_pf(k,j,i) = t_surf_window_v(l)%t(m)
+                   temp_pf(k,j,i) = t_surf_window_v(l)%val(m)
                 ENDDO
              ENDIF
 
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%t_surf_window_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%t_surf_window_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3032,31 +2946,29 @@
 !--       Surface temperature for green surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = t_surf_green_h(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = t_surf_green_h(l)%val(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
                    j = surf_usm_v(l)%j(m)
                    k = surf_usm_v(l)%k(m)
-                   temp_pf(k,j,i) = t_surf_green_v(l)%t(m)
+                   temp_pf(k,j,i) = t_surf_green_v(l)%val(m)
                 ENDDO
              ENDIF
 
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%t_surf_green_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%t_surf_green_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3074,13 +2986,12 @@
 !--       Near surface temperature for whole surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%pt_10cm(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%pt_10cm(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3093,13 +3004,12 @@
 
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%pt_10cm_av(m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%pt_10cm_av(m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3116,30 +3026,28 @@
 !--       Wall temperature for  iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = t_wall_h(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = t_wall_h(l)%val(iwl,m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
                    j = surf_usm_v(l)%j(m)
                    k = surf_usm_v(l)%k(m)
-                   temp_pf(k,j,i) = t_wall_v(l)%t(iwl,m)
+                   temp_pf(k,j,i) = t_wall_v(l)%val(iwl,m)
                 ENDDO
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%t_wall_av(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%t_wall_av(iwl,m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3155,30 +3063,28 @@
 !--       Window temperature for iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = t_window_h(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = t_window_h(l)%val(iwl,m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
                    j = surf_usm_v(l)%j(m)
                    k = surf_usm_v(l)%k(m)
-                   temp_pf(k,j,i) = t_window_v(l)%t(iwl,m)
+                   temp_pf(k,j,i) = t_window_v(l)%val(iwl,m)
                 ENDDO
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%t_window_av(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%t_window_av(iwl,m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3194,30 +3100,28 @@
 !--       Green temperature for  iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = t_green_h(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = t_green_h(l)%val(iwl,m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
                    j = surf_usm_v(l)%j(m)
                    k = surf_usm_v(l)%k(m)
-                   temp_pf(k,j,i) = t_green_v(l)%t(iwl,m)
+                   temp_pf(k,j,i) = t_green_v(l)%val(iwl,m)
                 ENDDO
              ENDIF
           ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%t_green_av(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%t_green_av(iwl,m)
                 ENDDO
              ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3233,24 +3137,21 @@
 !--       Soil water content for  iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = swc_h(iwl,m)
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = swc_h(l)%val(iwl,m)
+                ENDDO
+             ENDIF
+          ELSE
+             IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+                   temp_pf(k,j,i) = surf_usm_h(l)%swc_av(iwl,m)
                 ENDDO
              ELSE
-
-             ENDIF
-          ELSE
-             IF ( idsint == iup )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-                   k = surf_usm_h%k(m)
-                   temp_pf(k,j,i) = surf_usm_h%swc_av(iwl,m)
-                ENDDO
-             ELSE
-                l = idsidx
                 DO  m = 1, surf_usm_v(l)%ns
                    i = surf_usm_v(l)%i(m)
@@ -3334,5 +3235,5 @@
 !> Initialization of the wall surface model
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE usm_init_material_model
+ SUBROUTINE usm_init_wall_heat_model
 
     IMPLICIT NONE
@@ -3340,5 +3241,5 @@
     INTEGER(iwp) ::  k, l, m  !< running indices
 
-    IF ( debug_output )  CALL debug_message( 'usm_init_material_model', 'start' )
+    IF ( debug_output )  CALL debug_message( 'usm_init_wall_heat_model', 'start' )
 
 !
